/*
 * DTMFDialog - dialog to ask for DTMF to be sent on active call
 */

import java.awt.*;
import java.applet.*;
import java.util.*;

public class DTMFDialog extends Dialog {

	void okButton_Clicked( Event event ) {

		hide();
		collectInfo();
		dispose();
	}

	void cancelButton_Clicked(Event event) {

        hide();
		dispose();
	}


	public DTMFDialog(Frame parent, boolean modal) {
		super(parent, modal);

		//{{INIT_CONTROLS
		setLayout(null);
		addNotify();
		resize(insets().left + insets().right + 363,insets().top + insets().bottom + 185);
		setFont(new Font("Helvetica", Font.PLAIN, 11));
		mainPanel = new java.awt.Panel();
		mainPanel.setLayout(null);
		mainPanel.reshape(insets().left + 2,insets().top + 5,359,176);
		add(mainPanel);
		okButton = new java.awt.Button("OK");
		okButton.reshape(182,140,88,20);
		mainPanel.add(okButton);
		cancelButton = new java.awt.Button("Cancel");
		cancelButton.reshape(88,140,88,20);
		mainPanel.add(cancelButton);
		TserverInfoPanel = new java.awt.Panel();
		TserverInfoPanel.setLayout(null);
		TserverInfoPanel.reshape(4,5,353,126);
		TserverInfoPanel.setFont(new Font("Helvetica", Font.PLAIN, 11));
		mainPanel.add(TserverInfoPanel);
		DTMFButton = new java.awt.Label("Send DTMF:", Label.RIGHT );
		DTMFButton.reshape(71,63,78,20);
		TserverInfoPanel.add(DTMFButton);
		dtmfTextfield = new java.awt.TextField();
		dtmfTextfield.reshape(157,63,124,20);
		dtmfTextfield.setBackground(new Color(16777215));
		TserverInfoPanel.add(dtmfTextfield);
		setTitle("");
		//}}
	}
	
	public DTMFDialog(Frame _parent, String title, boolean modal, MyTextArea mainTrace) {
	    this(_parent, modal);
	    setTitle(title);
	    trace = mainTrace;
	    parent = _parent;
	}
	
	public synchronized void show() {
    	Rectangle bounds = getParent().bounds();
    	Rectangle abounds = bounds();

    	move(bounds.x + (bounds.width - abounds.width)/ 2,
    	     bounds.y + (bounds.height - abounds.height)/2);

    	super.show();
    }

   /*
    * handleEvent()
    * This method handles button interactions.
    */
    public boolean handleEvent(Event event) {
		if(event.id == Event.WINDOW_DESTROY) {
	        hide();
	        return true;
	    }
		if ( event.target == cancelButton && event.id == Event.ACTION_EVENT ) {
			cancelButton_Clicked( event );
			return true;
		}
		if ( event.target == okButton && event.id == Event.ACTION_EVENT ) {
			okButton_Clicked( event );
			return true;
		}
		
		return super.handleEvent(event);
	}

   /*
    * keyDown()
    * This method handles the Return and ESC keys being pressed.
    */
    public boolean keyDown(Event event, int key) {
	    if ((event.id == Event.KEY_PRESS)) {
    	    switch ((char)key) {
    	        case '\n':
	                okButton_Clicked( event );
	                return true;
	            case '\033':
	                cancelButton_Clicked(event);
	                return true;
	            default:
	                break;
	        }
	    }
	    return false;
    }

   /*
    * collectInfo()
    * This method collects information provided in dialog box and calls
    * the sendDTMF method of the CallLog class
    */
    public void collectInfo() {
        String          dtmf;
        Hashtable       args = new Hashtable(2);
        
        args.put("function", "sendDTMF");
		dtmf = dtmfTextfield.getText();

		args.put("dtmf", dtmf);
		lastDTMF = new String( dtmf );
		
		(new FunctionHandler ( parent, args )).start();           
    }

	//{{DECLARE_CONTROLS
	java.awt.Panel mainPanel;
	java.awt.Button okButton;
	java.awt.Button cancelButton;
	java.awt.Panel TserverInfoPanel;
	java.awt.Label DTMFButton;
	java.awt.TextField dtmfTextfield;
	//}}
	Frame           parent;
	MyTextArea      trace;
	static String   lastDTMF = "";
}
