/*
 * LoginDialog - dialog to ask for login information
 */

import java.awt.*;
import java.applet.*;
import java.util.*;

public class LoginDialog extends Dialog {

	void loginButton_Clicked( Event event ) {

		hide();
		collectInfo();
		dispose();
	}

	void cancelButton_Clicked(Event event) {

        hide();
		dispose();
	}


	public LoginDialog(Frame parent, boolean modal) {
		super(parent, modal);

		// user interface defined here
		//{{INIT_CONTROLS
		setLayout(null);
		addNotify();
		resize(insets().left + insets().right + 363,insets().top + insets().bottom + 215);
		setFont(new Font("Helvetica", Font.PLAIN, 12));
		mainPanel = new java.awt.Panel();
		mainPanel.setLayout(null);
		mainPanel.reshape(insets().left + 2,insets().top + 5,359,205);
		mainPanel.setFont(new Font("Helvetica", Font.PLAIN, 11));
		add(mainPanel);
		cancelButton = new java.awt.Button("Cancel");
		cancelButton.reshape(88,176,88,20);
		mainPanel.add(cancelButton);
		loginButton = new java.awt.Button("Login");
		loginButton.reshape(182,176,88,20);
		mainPanel.add(loginButton);
		TserverInfoPanel = new java.awt.Panel();
		TserverInfoPanel.setLayout(null);
		TserverInfoPanel.reshape(5,4,353,165);
		TserverInfoPanel.setFont(new Font("Helvetica", Font.PLAIN, 11));
		mainPanel.add(TserverInfoPanel);
		tlinkCombo = new java.awt.Choice();
		TserverInfoPanel.add(tlinkCombo);
		tlinkCombo.reshape(146,38,202,21);
		tlinkCombo.setBackground(new Color(16777215));
		loginTextfield = new java.awt.TextField();
		loginTextfield.reshape(146,66,106,20);
		loginTextfield.setBackground(new Color(16777215));
		TserverInfoPanel.add(loginTextfield);
		passwordTextfield = new java.awt.TextField();
		passwordTextfield.setEchoCharacter('*');
		passwordTextfield.reshape(146,93,106,20);
		passwordTextfield.setBackground(new Color(16777215));
		TserverInfoPanel.add(passwordTextfield);
		callingExtTextfield = new java.awt.TextField();
		callingExtTextfield.reshape(146,120,106,20);
		callingExtTextfield.setBackground(new Color(16777215));
		TserverInfoPanel.add(callingExtTextfield);
		extButton = new java.awt.Label("Extension:", Label.RIGHT );
		extButton.reshape(70,120,70,20);
		TserverInfoPanel.add(extButton);
		
		pwdButton = new java.awt.Label("Password:", Label.RIGHT );
		pwdButton.reshape(70,93,70,20);
		TserverInfoPanel.add(pwdButton);
		
		loginIDButton = new java.awt.Label("Login:", Label.RIGHT );
		loginIDButton.reshape(95,67,45,20);
		TserverInfoPanel.add(loginIDButton);
		
		serviceButton = new java.awt.Label("Service ID:", Label.RIGHT );
		serviceButton.reshape(71,41,69,20);
		TserverInfoPanel.add(serviceButton);
		setTitle("Tserver Login");
		//}}
		
	}
	
	public LoginDialog(Frame _parent, String title, boolean modal, MyTextArea mainTrace, Hashtable preferences) {
		this(_parent, modal);
	    setTitle(title);
	    trace = mainTrace;
	    parent = _parent;
	    String[] tlinks = ( (CallLog) _parent).getServices();
	    if (tlinks != null) {
	        for ( int i=0; i < tlinks.length; i++ ) {
        	    tlinkCombo.addItem( tlinks[i] );
        	}
	    }
	    
	    if ( preferences != null ) {
		    lastTlink = new String( (String) preferences.get( "tlink" ) );
        	lastLogin = new String( (String) preferences.get( "login" ) );
        	lastPassword = new String( (String) preferences.get( "password" ) );
        	lastDevice =  new String( (String) preferences.get( "device" ) );
		}
	    
	    if ( lastTlink != null ) {
		    tlinkCombo.select ( lastTlink.toUpperCase() );
        }
        loginTextfield.setText(	lastLogin );
        passwordTextfield.setText( lastPassword );
        callingExtTextfield.setText( lastDevice  );
	}
	
	public synchronized void show() {
    	Rectangle bounds = getParent().bounds();
    	Rectangle abounds = bounds();

    	move(bounds.x + (bounds.width - abounds.width)/ 2,
    	     bounds.y + (bounds.height - abounds.height)/2);

    	super.show();
    }

   /*
    * handleEvent()
    * This method handles button interactions.
    */
    public boolean handleEvent(Event event) {
		if(event.id == Event.WINDOW_DESTROY) {
	        hide();
	        return true;
	    }
		if ( event.id == Event.ACTION_EVENT ) {
    		if ( event.target == cancelButton ) {
    			cancelButton_Clicked( event );
    			return true;
    		} else if (event.target == loginButton ) {
    			loginButton_Clicked(event);
    			return true;
    		}
		} else if (  event.id == Event.GOT_FOCUS ) {
            if ( event.target instanceof TextField) {
    	        ((TextField) event.target).selectAll();
    	    }
    	} else if (  event.id == Event.LOST_FOCUS ) {
    	    if ( event.target instanceof TextField) {
    	        ((TextField) event.target).select(0, 0);
    	    }
    	}
		return super.handleEvent(event);
	}

   /*
    * keyDown()
    * This method handles the Return and ESC keys being pressed.
    */
    public boolean keyDown(Event event, int key) {
	    if ((event.id == Event.KEY_PRESS)) {
    	    switch ((char)key) {
    	        case '\n':
	                loginButton_Clicked( event );
	                return true;
	            case '\033':
	                cancelButton_Clicked(event);
	                return true;
	            default:
	                break;
	        }
	    }
	    return false;
    }

   /*
    * login()
    * This method creates the JtapiPeer and the Provider
    */
    public void collectInfo() {
        String          serviceID;
        String          login;
        String          password;
        String          callingExt;
        Hashtable       args = new Hashtable(6);
        
        args.put("function", "login");
		serviceID = tlinkCombo.getSelectedItem();
		login = loginTextfield.getText();
		password = passwordTextfield.getText();
        callingExt = callingExtTextfield.getText();
        
        lastTlink = new String(serviceID);
        lastLogin = new String(login);
        lastPassword = new String(password);
        lastDevice = new String(callingExt);
        
		args.put("serviceID", serviceID);
		args.put("login", login);
		args.put("password", password);
		args.put("callingExt", callingExt);
		
		(new FunctionHandler ( parent, args )).start();
    }

	//{{DECLARE_CONTROLS
	java.awt.Panel mainPanel;
	java.awt.Button cancelButton;
	java.awt.Button loginButton;
	java.awt.Panel TserverInfoPanel;
	java.awt.Choice tlinkCombo;
	java.awt.TextField callingExtTextfield;
	java.awt.TextField passwordTextfield;
	java.awt.TextField loginTextfield;
	java.awt.Label extButton;
	java.awt.Label pwdButton;
	java.awt.Label loginIDButton;
	java.awt.Label serviceButton;
	//}}
	Frame       parent;
	MyTextArea  trace;
	static String   lastTlink;
	static String   lastLogin;
	static String   lastPassword;
	static String   lastDevice;
	
}
