/*
 * UUIDialog - dialog to get destination and UUI information to make call
 */

import java.awt.*;
import java.applet.*;
import java.util.*;

public class UUIDialog extends Dialog {

	void okButton_Clicked( Event event ) {

		hide();
		collectInfo();
		dispose();
	}

	void cancelButton_Clicked(Event event) {

        hide();
		dispose();
	}


	public UUIDialog(Frame parent, boolean modal) {
		super(parent, modal);

		//{{INIT_CONTROLS
		setLayout(null);
		addNotify();
		resize(insets().left + insets().right + 363,insets().top + insets().bottom + 215);
		setFont(new Font("Helvetica", Font.PLAIN, 12));
		setBackground(new Color(12632256));
		mainPanel = new java.awt.Panel();
		mainPanel.setLayout(null);
		mainPanel.reshape(insets().left + 0,insets().top + 0,359,205);
		mainPanel.setFont(new Font("Helvetica", Font.PLAIN, 12));
		mainPanel.setBackground(new Color(12632256));
		add(mainPanel);
		cancelButton = new java.awt.Button("Cancel");
		cancelButton.reshape(84,180,88,20);
		mainPanel.add(cancelButton);
		TserverInfoPanel = new java.awt.Panel();
		TserverInfoPanel.setLayout(null);
		TserverInfoPanel.reshape(0,0,353,165);
		TserverInfoPanel.setFont(new Font("Helvetica", Font.PLAIN, 12));
		TserverInfoPanel.setBackground(new Color(12632256));
		mainPanel.add(TserverInfoPanel);
		destTextfield = new java.awt.TextField();
		destTextfield.reshape(168,24,132,20);
		TserverInfoPanel.add(destTextfield);
		destTextfield.setText ( lastCalledDev );
		uuiTextfield = new java.awt.TextField();
		uuiTextfield.reshape(168,60,175,20);
		TserverInfoPanel.add(uuiTextfield);
		UUIButton = new java.awt.Label("User To User Information:", Label.RIGHT );
		UUIButton.reshape(6,60,156,20);
		TserverInfoPanel.add(UUIButton);
		
		dirButton = new java.awt.Label("Directory:", Label.RIGHT );
		dirButton.reshape(102,96,60,20);
		TserverInfoPanel.add(dirButton);
		
		dirCombo = new java.awt.Choice();
		dirCombo.reshape(168,96,132,24);
		TserverInfoPanel.add(dirCombo);
		labelButton1 = new java.awt.Label("Destination:", Label.RIGHT );
		labelButton1.reshape(84,24,78,20);
		TserverInfoPanel.add(labelButton1);
		
		okButton = new java.awt.Button("OK");
		okButton.reshape(180,180,88,20);
		mainPanel.add(okButton);
		setTitle("");
		//}}
	}
	
	public UUIDialog( Frame _parent, String title, boolean modal, MyTextArea mainTrace, Hashtable phoneDirectory ) {
	    this(_parent, modal);
	    setTitle(title);
	    trace = mainTrace;
	    parent = _parent;
	    if ( phoneDirectory != null ) {
	        directory = phoneDirectory;
	        populateComboBox();
	    }
	}
	
	public void populateComboBox () {
	    
	    String[]    nameArray = new String[ directory.size() ];
	    int         i = 0;
	    Enumeration names;
	    
	    names = directory.keys();
	    if (names != null) {
	        while ( names.hasMoreElements() ) {
    	        dirCombo.addItem( (String) names.nextElement() );
    	    }
    	}
    	dirCombo.select(-1);
	}
	
	public synchronized void show() {
    	Rectangle bounds = getParent().bounds();
    	Rectangle abounds = bounds();

    	move(bounds.x + (bounds.width - abounds.width)/ 2,
    	     bounds.y + (bounds.height - abounds.height)/2);

    	super.show();
    }

   /*
    * handleEvent()
    * This method handles button interactions.
    */
    public boolean handleEvent(Event event) {
		if(event.id == Event.WINDOW_DESTROY) {
	        hide();
	        return true;
	    }
		if ( event.target == cancelButton && event.id == Event.ACTION_EVENT ) {
			cancelButton_Clicked( event );
			return true;
		}
		if ( event.target == okButton && event.id == Event.ACTION_EVENT ) {
			okButton_Clicked( event );
			return true;
		}
		if ( event.target == dirButton && event.id == Event.ACTION_EVENT ) {
			trace.appendText("Destination: this field represents the destination number for the call\n\n");
			return true;
		}
		return super.handleEvent(event);
	}

   /*
    * keyDown()
    * This method handles the Return and ESC keys being pressed.
    */
    public boolean keyDown(Event event, int key) {
	    if ((event.id == Event.KEY_PRESS)) {
    	    switch ((char)key) {
    	        case '\n':
	                okButton_Clicked( event );
	                return true;
	            case '\033':
	                cancelButton_Clicked(event);
	                return true;
	            default:
	                break;
	        }
	    }
	    return false;
    }

   /*
    * collectInfo()
    * This method collects information provided in dialog box and calls
    * the makeCall method of the CallLog class
    */
    public void collectInfo() {
        String          calledString;
        String          uui;
        Hashtable       args = new Hashtable(3);
        
        args.put("function", "makecall");
		
		if ( dirCombo.getSelectedIndex() != -1 ) {
            calledString = dirCombo.getSelectedItem();
            lastCalledDev = "";
		} else {
            calledString = destTextfield.getText();
            lastCalledDev = new String ( calledString );
		}
		uui = uuiTextfield.getText();


		if (calledString != null) {
		    args.put("calledString", calledString);
		    args.put("uui", uui);
		
    		lastUUI = new String ( uui );
    		
    		(new FunctionHandler ( parent, args )).start();  
        }
    }

	//{{DECLARE_CONTROLS
	java.awt.Panel mainPanel;
	java.awt.Button cancelButton;
	java.awt.Panel TserverInfoPanel;
	java.awt.TextField uuiTextfield;
	java.awt.Label UUIButton;
	java.awt.Label dirButton;
	java.awt.Choice dirCombo;
	java.awt.Label labelButton1;
	java.awt.TextField destTextfield;
	java.awt.Button okButton;
	//}}
	Frame           parent;
	MyTextArea      trace;
	Hashtable       directory;
	static String   lastUUI = "";
	static String   lastCalledDev = "";
}
